from kivy.app import App
from kivy.uix.widget import Widget
from kivy.clock import Clock
from kivy.properties import StringProperty,ObjectProperty,NumericProperty,ListProperty,BooleanProperty
from kivy.uix.button import Button
from kivy.uix.gridlayout import GridLayout
from kivy.uix.boxlayout import BoxLayout
from kivy.uix.screenmanager import ScreenManager, Screen, FadeTransition , SlideTransition , WipeTransition , ShaderTransition, SwapTransition
from kivy.uix.label import Label
from kivy.lang import Builder
from kivy.core.audio import SoundLoader, Sound
from kivy.uix.image import AsyncImage
from kivy.uix.progressbar import ProgressBar
from kivy.uix.video import Video
from keymaker import KeyMaker
from project.peri import PeriBoard
import usb
from sys import exit

Builder.load_string("""
#:set clicked (0,1,0)
#:set normal (1,1,1)

<MyBorder>:
    size: 10,10
    #id: grid_layout
    center_x: self.parent.center_x
    center_y: (self.parent.center_y) - 50
    rows: 4
    cols: 4
    spacing: 10

<SmashSongGame>:
    id: songgame
        
<SmashButton>:
    background_color: 0.2,1,0,1
    background_down: ''
    background_normal: 'atlas://data/images/defaulttheme/button_pressed'
    color: 1,0,0,1
    #text: ctx.text if hassattr(ctx,'text') else ''
    font_size: 60
    markup: True
    on_press: self.pressing()

<StartScreen>:
    button: but1
    Widget:
        AsyncImage:
            size: root.size
            center: self.parent.center
            source: 'ui/animation-gif-686371.gif'
        Label:
            text: "SMASH BOO!!"
            color: 0,1,0,0.5
            font_size: 140
            center_x: root.center_x
            center_y: root.center_y + 100
            font_name: 'font/particulator_ii/particulator_ii.ttf'
        Label:
            text: "SMASH BOO!!"
            color: 0,1,0.1,1
            font_size: 120
            center_x: root.center_x
            center_y: root.center_y + 100
            font_name: 'font/particulator_ii/particulator_ii.ttf'
        BoxLayout:
            id: box
            size: 100,100
            center_x: root.center_x
            center_y: root.center_y - 120
            orientation: 'vertical'
            spacing: 10
            Button:
                id: but1
                background_color: 1,0,0,1
                text: 'Start'
                font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
                color: 1,0.3,0,1
                font_size: 40
                on_press: root.toSelectScreen()
            Button:
                text: 'Exit'
                background_color: 1,0.3,0,1
                font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
                color: 1,0.3,0,1
                font_size: 40
                on_press: exit()
<SelectScreen>:
    wid: wid
    switch: switch
    Widget:
        id: wid
        AsyncImage:
            size: root.size
            center: self.parent.center
            source: 'ui/animation-gif-686371.gif'
        BoxLayout:
            size: 100,100
            center: root.center
            orientation: 'vertical'
            spacing: 10
            Button:
                background_color: 1,0,0,1
                text: 'Play'
                font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
                color: 1,0.3,0,1
                font_size: 40
                on_press: root.toPlayScreen()
            Button:
                background_color: 1,0,0,1
                text: 'Back'
                font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
                color: 1,0.3,0,1
                font_size: 40
                on_press: root.toStartScreen()
            Switch:
                id: switch
                size: 40,40
             
<PlayScreen>:
    myborder: myborder
    player: player
    center: self.center
    mybar: mybar
    Widget:
        AsyncImage:
            size: root.size
            center: self.parent.center
            source: 'ui/animation-gif-686371.gif'
        ProgressBar:
            id: mybar
            size: 500,300
            center_x: self.parent.center_x
            center_y: self.parent.center_y + 180
            max: 100
            value: 0
    MyBorder:
        id: myborder
        size: 415,415
        size_hint: None,None
        center_x: self.parent.center_x
        center_y: self.parent.center_y - 80
    SmashPlayer:
        id: player
        Label:
            id: score
            font_name: 'font/particulator_ii/particulator_ii.ttf'
            font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
            color: 1,0.3,0,1
            font_size: 40
            top: self.parent.parent.top
            center_x: 0+75
            text: "Score: %d" % (self.parent.score)
        Label:
            id: combo
            font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
            color: 1,0.3,0,1
            font_size: 40
            top: self.parent.parent.top
            center_x: self.parent.parent.width - 75
            text: "Combo: %d" % (self.parent.combo)

<ResultScreen>:
    Widget:
        Label:
            font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
            text: "Thank for playing :) By Gotzillaz & funkikunki"
            color: 1,0.3,0,1
            font_size: 40
            center_x: self.parent.center_x
            center_y: self.parent.center_y + 35
        BoxLayout:
            size: 100,100
            center_x: root.center_x
            center_y: self.parent.center_y - 35
            orientation: 'vertical'
            spacing: 10
            Button:
                background_color: 1,0,0,1
                text: 'Back'
                font_name: 'font/ubuntu/UbuntuMono-B-Powerline.otf'
                color: 1,0.3,0,1
                font_size: 40
                on_press: root.toSelectScreen()
""")

class SmashSongGame(Widget):
    pass
#################################################################
# Sound Zone
songname = "song/connect/connect"
audio = SoundLoader.load(songname+".mp3")
vid = Video(source=songname+'.avi')
sfx = SoundLoader.load('sfx/_clap.ogg')
enableClap = False
time = 0.0
totalscore = 0.0
def getAUtime(args):
    time = audio.get_pos()
    return audio.get_pos()
def seekSong(args):
    audio.seek(85)
def playSong(args):
    global vid
    audio.play()
    vid.state = 'play'
##################################################################
# PeriBoard Zone

#input_board = PeriBoard()

def chk_a_board():
    board = PeriBoard()
    bit_num = board.getData()
    click_list = []
    for i in xrange(16):
        if (bit_num >> i)&1:
            click_list.append(i)
    return click_list

def receiveKeyPress(click_list):
    global keymanager
    time = getAUtime(0)
    for x in click_list:
        xy = keymanager.n_to_xy(x)
        getKeyPress(xy[0],xy[1],time)

def sendKeyPress(key_x,key_y):
    global keymanager
    board = PeriBoard()
    xy = keymanager.xy_to_n([key_x,key_y])
    board.setData(0b00100000,1<<xy)
##################################################################
# KeyManager Zone
keyMap = [[[],[],[],[]],[[],[],[],[]],[[],[],[],[]],[[],[],[],[]]]
keyPress = [[[],[],[],[]],[[],[],[],[]],[[],[],[],[]],[[],[],[],[]]]
keymanager = KeyMaker("")
def readMapper():
    global keyMap
    keymanager.changeFile(songname+".smk")
    all_lines = keymanager.KeyReader()
    keyMap = keymanager.KeyParser(all_lines)
    print keyMap
def readMap(filename):
    keyfile = open(filename,'r')
    all_lines = keyfile.readlines()
    for x in all_lines:
        i,j,times = map(float, x.split())
        keyMap[int(i)][int(j)].append(times)

def getKeyPress(x,y,times):
    global keyPress
    keyPress[x][y].append(times)

def resetMap():
    keyMap = [[[],[],[],[]],[[],[],[],[]],[[],[],[],[]],[[],[],[],[]]]

##################################################################
# Result Zone
maxcombo = 0
c_smash = 0
c_ok = 0
c_boo = 0
c_miss = 0
##################################################################
class SmashPlayer(Widget):
    global maxcombo 
    global c_smash
    global c_ok
    global c_boo
    global c_miss
    combo = NumericProperty(0)
    score = NumericProperty(0)
    chk = BooleanProperty(False)
    def resetCombo(self):
        self.combo = 0
    
    def resetScore(self):
        self.score = 0    

    def sendScore(self):
        totalscore = self.score
    
    def calcScore(self,press_t,note_t): # Should Change to Calculate Score
        global maxcombo 
        global c_smash 
        global c_ok
        global c_boo
        global c_miss
        diff = abs(press_t-note_t)
        if diff > 0.35 and diff <= 0.5:
            print "BOO " + str(c_boo+1) 
            c_boo += 1
            self.score += 25
        elif diff > 0.075 and diff <= 0.35:
            print "OK " + str(c_ok+1)
            c_ok += 1
            self.score += 50
        elif diff >= 0 and diff <= 0.075:
            print "Smash! " +str(c_smash+1)
            c_smash += 1
            self.score += 100
        else :
            print "Miss " + str(c_miss+1)
            return False
        self.combo += 1
        if self.combo > maxcombo:
            maxcombo = self.combo
        print "Max = " + str(maxcombo)
        return True

    def compareKey(self):
        global c_miss
        for i in xrange(4):
            for j in xrange(4):
                if(len(keyPress[i][j]) != 0 and len(keyMap[i][j]) != 0):
                    if(abs(keyMap[i][j][0]-keyPress[i][j][0])<=1):
                        self.chk = self.calcScore(keyPress[i][j][0],keyMap[i][j][0])
                if self.chk:
                    print "Delete: "+str(i)+" "+str(j)+" "+str(keyMap[i][j][0])
                    del keyMap[i][j][0]
                    global enableClap
                    if enableClap:
                        mysfx=SoundLoader.load('sfx/_clap.ogg')
                        mysfx.play()
                elif len(keyMap[i][j]) != 0 and getAUtime(0) > keyMap[i][j][0]:
                    c_miss += 1
                    print "Miss " + str(c_miss)
                    print "Delete: "+str(i)+" "+str(j)+" "+str(keyMap[i][j][0])
                    del keyMap[i][j][0]
                    mysfx=SoundLoader.load('sfx/_clap.ogg')
                    global enableClap
                    if enableClap:
                        mysfx.play()
                    if(not self.chk):
                        self.resetCombo()
                if len(keyPress[i][j])!= 0:
                    del keyPress[i][j][0]
                keyPress[i][j] = []
                self.chk = False
        
class MyBorder(GridLayout): # Use to keep GridLayout(Scalable)

    def __init__(self,**kwargs):
        super(MyBorder, self).__init__(**kwargs)
        for x in xrange(4):
            for y in xrange(4):
                self.add_widget(SmashButton(id='b'+str(x)+str(y),mx=x,my=y))

class SmashButton(Button): # Button is this game
    mx = NumericProperty(0)
    my = NumericProperty(0)
    display = NumericProperty(0)
    timeold = NumericProperty(0) 
    def __init__(self,**kwargs):
        super(SmashButton, self).__init__(**kwargs)
        self.mx=kwargs["mx"]
        self.my=kwargs["my"]
    def pressing(self):
        print str(self.mx)+" "+str(self.my)
        getKeyPress(self.mx,self.my,getAUtime(0))
        self.text = ""
        self.display = 0
        self.setTextBlank()
    def setTextBlank(self,*largs):
        self.text = ""
        self.display = 0
    def updateText(self,*largs): # Change Text in each Button when has note
        if len(keyMap[self.mx][self.my]) != 0:
            if self.timeold!= keyMap[self.mx][self.my][0] and 1 < keyMap[self.mx][self.my][0] - getAUtime(0) <= 1.5 and self.display==0:
                self.text = "2"
                self.display += 1
            elif 0.5 < keyMap[self.mx][self.my][0] - getAUtime(0) <= 1:
                self.text = "1"
                self.display += 1
            elif  self.timeold!= keyMap[self.mx][self.my][0] and 0.05< keyMap[self.mx][self.my][0] - getAUtime(0) <= 0.5:
                self.text = "0"
                self.display += 1
                sendKeyPress(self.mx,self.my) ##
                self.timeold = keyMap[self.mx][self.my][0]
                print "AA"
            elif 0 < keyMap[self.mx][self.my][0] - getAUtime(0) <= 0.05:
                a = 10
            else:
                self.setTextBlank()
    def toSelectScreen(self):
        button_sound = SoundLoader.load('sfx/button.ogg')
        button_sound.play()
        self.parent.current = 'selectscr'
class StartScreen(Screen): # First Screen of Game
    def toSelectScreen(self):
        self.parent.current = 'selectscr'
        button_sound = SoundLoader.load('sfx/button.ogg')  
        button_sound.play()

class SelectScreen(Screen): # Select song screen
    def toPlayScreen(self):
        global sfx
        global enableClap
        button_sound = SoundLoader.load('sfx/button.ogg')
        button_sound.play()
        Clock.schedule_once(playSong,3)
        readMapper()
        sfx.stop()
        sfx.loop=False
        sfx = SoundLoader.load('sfx/_clap.ogg')
        if self.switch.active == True:
            enableClap = True
        else:
            enableClap = False
        self.parent.current = 'playscr'

    def toStartScreen(self):
        button_sound = SoundLoader.load('sfx/button.ogg')
        button_sound.play()
        self.parent.current = 'startscr'

class Mytime(Label):
    def toResultScreen(self,args):
        self.parent.parent.current = 'resultscr'
        audio.stop()
        self.parent.player.sendScore()
        self.parent.player.score = 0
        self.parent.player.combo = 0

    def update(self,dummy):
        receiveKeyPress(chk_a_board()) ##
        button_list = self.parent.myborder.children
        self.parent.mybar.max = audio.length
        self.parent.mybar.value = getAUtime(0)
        for btn in button_list:
            btn.updateText()
        self.text = "Time: "+str(int(getAUtime(dummy)))
        self.parent.player.compareKey()
        if(audio.get_pos() >= audio.length-0.05):
            Clock.schedule_once(self.toResultScreen,3)
    
    def __init__(self,**kwargs):
        super(Mytime, self).__init__(**kwargs)
        Clock.schedule_interval(self.update,1.0/120)

class PlayScreen(Screen): # Play Screen (MyBoarder in this screen)
    player = ObjectProperty()
    def __init__(self,**kwargs):
        super(PlayScreen, self).__init__(**kwargs)
        self.add_widget(Mytime( font_name='font/ubuntu/UbuntuMono-B-Powerline.otf',color= [1,0.3,0,1], font_size= 40,top=self.top + 300))

class ResultScreen(Screen): # Result Screen (Show your score)
    ss = ObjectProperty()
    global maxcombo 
    global c_smash
    global c_ok
    global c_boo
    global c_miss
    def toSelectScreen(self):
        button_sound = SoundLoader.load('sfx/button.ogg')
        button_sound.play()
        global sfx
        sfx = SoundLoader.load('sfx/main(loop).ogg')
        sfx.loop = True
        sfx.play()
        self.parent.current = 'selectscr'
    def __init__(self,**kwargs):
        global maxcombo 
        global c_smash 
        global c_ok
        global c_boo
        global c_miss
        super(ResultScreen, self).__init__(**kwargs)
        self.add_widget(Label(text=str(c_miss),top=self.top - 100))
class SmashApp(App):
    def build(self):
        global sfx
        sm = ScreenManager(transition=SlideTransition(direction='left'))
        
        sm.add_widget(StartScreen(name='startscr'))
        sm.add_widget(SelectScreen(name='selectscr'))
        sm.add_widget(PlayScreen(name='playscr'))
        sm.add_widget(ResultScreen(name='resultscr'))
        sm.current = 'startscr'
        sfx = SoundLoader.load('sfx/main(loop).ogg')
        sfx.loop = True
        sfx.play()
        return sm

if __name__ == '__main__':
    SmashApp().run()
