#ifndef F_CPU
#define F_CPU 16000000L
#endif
#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include <avr/interrupt.h>  /* for sei() */
#include "usbdrv/usbdrv.h"
#define BIT_COUNT 4
#define BIT_RESET 5
#define BIT_DS0 0
#define BIT_DS1 1
#define BIT_SHCP 2
#define BIT_STCP 3 
#define BUTTON_DELAY 0b00001111
#define RQ_SET_DATA 0
#define RQ_GET_DATA 1
void DisplayDS0(uint8_t data, uint8_t bit_ds);
void ButtonScan();
void UpdateData(uint8_t *d);
uint8_t button[16] = {0};
uint16_t buttonData = 0;
uint8_t j = 0;
uint8_t k = 0;
uint8_t posDS0;
uint8_t dataDS0[16];
uint8_t i = 0;
//uint8_t tmpPINC=0;
//uint8_t posDS1;
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;
    //static uint8_t switch_state;  /* must stay valid when usbFunctionSetup returns */
    if (rq->bRequest == RQ_GET_DATA)
    {
        usbMsgPtr = (uchar*) &buttonData; 
     	return 2;
    }

    else if (rq->bRequest == RQ_SET_DATA)
    {
	    //dataDS0[1] = 0b11111111;
	    uint8_t val0 = rq->wValue.bytes[0];
	    //uint8_t val1 = rq->wIndex.bytes[0];
	    uint8_t val1 = rq->wValue.bytes[1];
	    for (j=0;j<8;j++)
	    {
		    if(((val0>>j) & 0b00000001) == 0b00000001)
		    {
			    dataDS0[j] = 0b11111111;
		    }
		    if(((val1>>j) & 0b00000001) == 0b00000001)
		    {
		    	dataDS0[j+8] = 0b11111111;
		    }
	    }
        return 0;          
        /* point usbMsgPtr to the data to be returned to host */
        //usbMsgPtr = (uchar*) &switch_state;
        /* return the number of bytes of data to be returned to host */
        //return sizeof(2);
	    //return 2;
    }

    return 0;   /* default for not implemented requests: return no data back to host */
}
main()
{
	dataDS0[0] = 0b00000001;
	dataDS0[1] = 0b00000011;
	dataDS0[2] = 0b00000111;
	dataDS0[3] = 0b01111111;
	dataDS0[4] = 0b00001111;
	dataDS0[5] = 0b01111111;
	dataDS0[6] = 0b00000111;
	dataDS0[7] = 0b00000001;

	dataDS0[8] = 0b00000011;
	dataDS0[9] = 0b00000000;
	dataDS0[10] = 0b00000000;
	dataDS0[11] = 0b01011111;
	dataDS0[12] = 0b00000000;
	dataDS0[13] = 0b00000000;
	dataDS0[14] = 0b00000000;
	dataDS0[15] = 0b00000000;
	uint8_t count = 0;
	uint8_t modDS0 = 0;

	//set ports
    	PORTB = 0b00000000;  // กำหนดลอจิกขา PD7..0 เป็น 0
    	DDRB  = 0b00111111;
	PORTB = 0b00000000;  // กำหนดให้ขา PD3 ทำหน้าที่เอาท์พุท

	//PORTD = 0b01100011;
	DDRD |= 0b01100011;
	PORTD |= 0b01100011;

	PORTC = 0b00000000;
	DDRC = 0b00000000;
	PORTC = 0b11111111;
	
	PORTB &= (~(1<<BIT_COUNT)) ;
	PORTB |= 1<<BIT_RESET ;
	PORTB &= ~((1<<BIT_RESET)); 
	PORTB &= ~(1<<BIT_DS0);
	PORTB &= ~(1<<BIT_DS1);	
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);	
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);

	PORTB |= 1 << BIT_STCP;
	PORTB &= ~(1 << BIT_STCP);
	//endshift
	 
	usbInit();
	/* enforce re-enumeration, do this while interrupts are disabled! */
	usbDeviceDisconnect();
	_delay_ms(300);
	usbDeviceConnect();

	/* enable global interrupts */
	sei();
    while (1)
    {		//animation delay
		usbPoll();
		ButtonScan();
		//UpdateData(dataDS0);
		if (count==0b11111111 )
		{
			for(i=0;i<16;i++)
			{
				if (dataDS0[i] == 0)
				{
					//dataDS0[i] = 0b11111111;					
					//continue;
				}
			 	dataDS0[i] >>= 1;
			}
		}
		//_delay_ms(1);		
		DisplayDS0(0b00000000,BIT_DS0);
		DisplayDS0(0b00000000,BIT_DS1);
		modDS0 = count%8;
		
		if (modDS0==0)
		{
			PORTB |= 1<<BIT_RESET;
			PORTB &= ~(1<<BIT_RESET);
		}
		else
		{
			PORTB |= 1<< BIT_COUNT ;
			//_delay_ms(1);
			PORTB &= ~(1<< BIT_COUNT) ;
	
		}
		DisplayDS0(dataDS0[8+modDS0],BIT_DS1);
		DisplayDS0(dataDS0[modDS0],BIT_DS0);
		
		count++;          
          
        //_delay_ms(500);
		//PORTB &= ~(1<<BIT_DS0);
				//shift 8 times
		//_delay_ms(10);
		
		//_delay_ms(10);
		//
		//_delay_ms(100);
		//

    }
}
void DisplayDS0(uint8_t data, uint8_t bit_ds)
{
	PORTB &= ~(1<<bit_ds); 
	if (bit_ds-0 > 0)		
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 0));
	else 
		PORTB |= (1<<bit_ds) & (data >> (0 - bit_ds));
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-1 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 1));
	else 
		PORTB |= (1<<bit_ds) & (data >> (1 - bit_ds));
	//_delay_ms(1);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-2 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 2));
	else 
		PORTB |= (1<<bit_ds) & (data >> (2 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-3 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 3));
	else 
		PORTB |= (1<<bit_ds) & (data >> (3 - bit_ds));
		
	PORTB |= (1<<BIT_SHCP);	
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);	
	if (bit_ds-4 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 4));
	else 
		PORTB |= (1<<bit_ds) & (data >> (4 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);	
	if (bit_ds-5 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 5));
	else 
		PORTB |= (1<<bit_ds) & (data >> (5 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-6 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 6));
	else 
		PORTB |= (1<<bit_ds) & (data >> (6 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-7 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 7));
	else 
		PORTB |= (1<<bit_ds) & (data >> (7 - bit_ds));
	//PORTB |= (1<<bit_ds);
	PORTB |= (1<<BIT_SHCP);
	PORTB |= 1 << BIT_STCP;
	PORTB &= ~(1 << BIT_STCP);
}
void ButtonScan()
{
	
	for(j=0;j<16;j++)
	{
		if(button[j]>0)
		{
			button[j]-=1;
		}
		buttonData &= ~(1<<j);
	}
	for(k=0;k<4;k++)
	{
		
		
		
		//_delay_ms(1);
		posDS0 = 4*k;
		switch (k)
		{
			case 0:
				PORTD &= 0b11111110;
			break;
			case 1:
				PORTD &= 0b11111101;
			break;
			case 2:
				PORTD &= 0b11011111;
			break;
			case 3:
				PORTD &= 0b10111111;
			break;
		}
		PORTC |= 0b11111111;		
		//for(j=0;j<2;j++);
		if ((PINC & 0b00000001) == 0b00000000)
		{
			button[posDS0] = BUTTON_DELAY;
			buttonData = buttonData | (1<<(posDS0)); 
			//dataDS0[posDS0] = 0b11111111;
		}
		//for(j=0;j<1;j++);
		if ((PINC & 0b00000010) == 0b00000000)
		{
			button[posDS0+1] = BUTTON_DELAY;
			//dataDS0[posDS0+1] = 0b11111111;
			buttonData = buttonData | (1<<(posDS0+1));
		}
		if ((PINC & 0b00000100) == 0b00000000)
		{
			button[posDS0+2] = BUTTON_DELAY;
			buttonData = buttonData | (1<<(posDS0+2));
			//dataDS0[posDS0+2] = 0b11111111;
		}

		if ((PINC & 0b00001000) == 0b00000000)
		{
			button[posDS0+3] = BUTTON_DELAY;
			buttonData = buttonData | (1<<(posDS0+3));
			//dataDS0[posDS0+3] = 0b11111111;
		}
		//default:
		//button[4*k] = BUTTON_DELAY;
		//dataDS0[0] = 0b11111111;
		//PORTC |= 0b11111111;
		PORTD |= 0b01100011;
		//dataDS0[12] = 0b11111111;
		
		
	}
}
void UpdateData(uint8_t *d)
{
	for(j=0;j<16;j++)
	{
		if(((buttonData>>j) & 0b00000001) == 0b00000001 )
		{
			d[j] = 0b11111111;
		}
	}
	
}

